/******************************************************************************
 * Icinga 2                                                                   *
 * Copyright (C) 2018 Herrmann & Lenz Solutions GmbH (https://hl-solutions.de)*
 *                                                                            *
 * This program is free software; you can redistribute it and/or              *
 * modify it under the terms of the GNU General Public License                *
 * as published by the Free Software Foundation; either version 2             *
 * of the License, or (at your option) any later version.                     *
 *                                                                            *
 * This program is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 * GNU General Public License for more details.                               *
 *                                                                            *
 * You should have received a copy of the GNU General Public License          *
 * along with this program; if not, write to the Free Software Foundation     *
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ******************************************************************************/

#ifndef HLMONRECEIVER_H
#define HLMONRECEIVER_H

#include <SimpleAmqpClient/SimpleAmqpClient.h>

#include "hlmon/hlmonreceiver-ti.hpp"
#include "base/objectlock.hpp"
#include "base/timer.hpp"
#include "base/utility.hpp"
#include <iostream>
#include <thread>

namespace icinga
{

/**
 * @ingroup compat
 */
class HLMonReceiver : public ObjectImpl<HLMonReceiver>
{
public:
	DECLARE_OBJECT(HLMonReceiver);
	DECLARE_OBJECTNAME(HLMonReceiver);

	static void StatsFunc(const Dictionary::Ptr& status, const Array::Ptr& perfdata);

protected:
	virtual void Start(bool runtimeCreated) override;

private:
	std::thread m_ReceiveThread;

	void ReceiveThread();
	AmqpClient::Channel::ptr_t getChannel();
};

}

#endif /* HLMONRECEIVER_H */
